<?php

/**
 * Database export script/services for MODx installations
 *
 * @author Michiel Rook <info@touchdownconsulting.nl>
 * @version $Id: server.php 288 2010-03-24 19:51:59Z michiel $
 */

require_once '../manager/includes/config.inc.php';
require_once 'updserver_config.inc.php';

// check remote IP
if ($_SERVER['REMOTE_ADDR'] != $updserverRemoteAllowed) {
    echo "Not allowed\n";
    die();
}

// check provided secret
if ($_GET['token'] != md5($database_password)) {
    echo "Wrong token\n";
    die();
}

// dumps a mysql table, output similar to 'mysqldump'
function dumpTable($table) {
    global $dbase, $table_prefix, $database_server, $database_user, $database_password;
    
    $table = $table_prefix . $table;
    $db = str_replace('`', '', $dbase);

    $db = new PDO(
        "mysql:host={$database_server};dbname={$db}",
        $database_user, 
        $database_password, 
        array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8") 
    );

    $statement = $db->prepare("SHOW CREATE TABLE {$table}");
    $statement->execute();

    $row = $statement->fetch();

    echo $row[1] . ";\n\n";

    $statement = $db->prepare("SHOW COLUMNS FROM {$table}");
    $statement->execute();

    $fields = array();

    while ($row = $statement->fetch()) {
        $fields[] = $row[0];
    }

    $statement = $db->prepare("SELECT * FROM {$table}");
    $statement->execute();

    while ($row = $statement->fetch()) {
        $values = array();
        
        foreach ($fields as $field) {
            $val = addcslashes($row[$field], "\n\r'");
            
            if (!is_numeric($val)) {
                $val = "'" . $val . "'";
            }
            
            $values[] = $val;
        }
        
        echo "INSERT INTO {$table} VALUES(" . implode(',', $values) . ");\n";
    }
}

switch (trim($_GET['cmd'])) {
    case "chunks": {
        dumpTable('site_htmlsnippets');
    } break;

    case "documents": {
        dumpTable('site_content');
    } break;
    
    case "snippets": {
        dumpTable('site_snippets');
    } break;

    case "templates": {
        dumpTable('site_templates');
    } break;

    default: {
        echo "Illegal command\n"; 
    } break;
}
    
?>